/*
 * ActiveGroupsListNode.java
 *
 * Created on 03 September 2008, 15:36
 *
 * represents the Active List Group Nodes, encapsualte a group, its moves counter and its status flag
 * @author maya
 */

package GUIComponents;

/**
 *
 * 
 */
public class ActiveGroupsListNode {
    
    private Group group;
    private short redZoneflag; //0=OK, 1=in danger, 2= red zone
    private int movesCounter; //the number of moves this player played so far
   
    /** Creates a new instance of ActivePlayersListNode */
    public ActiveGroupsListNode(Group group) {
        this.group = group;
        this.redZoneflag=0;
        this.movesCounter=0;
    }
    
    //setters&getters
    public Group getGroup(){return this.group;}
    public void setPlayers(){this.group.setPlayersIndex();}
    public short getRedZoneFlag(){return this.redZoneflag;}
    public int getMovesCounter(){return this.movesCounter;}
    public void setRedZoneFlag(short newRedZoneFlag){this.redZoneflag = newRedZoneFlag;}
        
    //methods
    public void increaseMovesCounter(){this.movesCounter++;}
    public void setGroupIndx(int newGroupIndx){this.group.setIndex(newGroupIndx);}    
    public void initialize(short[] currentCase){this.group.initialize(currentCase);}
    public Move firstRound(){
        Move move = this.group.playFirstMove();
        if(move!=null){
            this.movesCounter++;
            this.redZoneflag=0;
        }
        //else    this.redZoneflag++;        
        return move;
    }
    public Move nextRound(int round, TMUInterface tmuInterface, GMUInterface gmuInterface, short gameFlag){
        Move roundMove= this.group.playNextRound(round,tmuInterface, gmuInterface, gameFlag, this.redZoneflag);
        if(roundMove==null){
            this.movesCounter++;
            this.redZoneflag=0;
        }
        else    this.redZoneflag++;
        return roundMove;
    }
    public String outPut(){
        return this.group.output();
    }
    
    protected InGroupMove[][] inGroupMoves(){return this.group.getInGroupMoves();}
}

