/*
 * CompressedArgTreeNode.java
 *
 * Created on 02 September 2008, 17:48
 *
 * Compressed Argumentation Tree Node is a compressed representation  of the actual Arg Tree Nodes, 
 * that comprises of the node information needed to translate it into Move later.
 *
 * @author maya
 */

package GUIComponents;

public class CompressedArgTreeNode {
     private int playerIndx;    //player index
     private int parentIndx;    //player's parent index
     private int round;         //round in which the move represented here was played
     private int leafIndx;      //if the node presented here was leaf then this parameter is its index
     
    ///contructor
    public CompressedArgTreeNode(int player, int parent, int level, int leaf) {
        this.playerIndx = player;
        this.parentIndx = parent;
        this.round = level;
        this.leafIndx = leaf;
    }
    //getters
    public int getPlayer() {return this.playerIndx;}
    public int getParent() {return this.parentIndx;}
    public int getRound() {return this.round;}
    public int getLeafIndx() {return this.leafIndx;}   
}

