/*
 * DynamicInGroupDialog.java
 *
 * Created on 08 October 2008, 15:01
 *
 * provides the jdialog screen to diplay the in groups dialogues
 *
 * @author maya
 */

package GUIComponents;
//java packages
import javax.swing.*;
import java.beans.*; //property change stuff
import java.awt.*;
import java.awt.event.*;

/**
 *
 * 
 */
public class DynamicInGroupDialog extends JDialog{
    //JPanel panel;
    JTabbedPane displayjtabbedPane;    
    JTextArea[] textAreasArray;
    InGroupMove[][][] ingroupDialogue;//groups//rounds//moves
    /** Creates a new instance of DynamicInGroupDialog */
    protected DynamicInGroupDialog(Frame aFrame,String[] groupsDescriptions) { 
        super(aFrame,"In Groups Dialogues",false);
        this.setDefaultCloseOperation(HIDE_ON_CLOSE);
        
        this.textAreasArray = new JTextArea[groupsDescriptions.length];
        this.ingroupDialogue = new InGroupMove[groupsDescriptions.length][][];
        this.displayjtabbedPane=new JTabbedPane();
        //add components
        for(int i=0; i<groupsDescriptions.length; i++){
            this.textAreasArray[i] = new JTextArea();
            this.displayjtabbedPane.add(groupsDescriptions[i], textAreasArray[i]);            
        }
        //The following line enables to use scrolling tabs.
        displayjtabbedPane.setTabLayoutPolicy(JTabbedPane.SCROLL_TAB_LAYOUT);
        this.add(this.displayjtabbedPane);
    }
    
    protected void outputIngroupDialogue(InGroupMove[][] ingroupMoves, int groupIndx){
        if(ingroupMoves==null){
            this.textAreasArray[groupIndx].setText("This Group Has No Moves in the Game\n");
        }
        else{     
            this.textAreasArray[groupIndx].setText("In Group Dialogue\n");
            for(int i=0; i<ingroupMoves.length; i++){
                this.textAreasArray[groupIndx].append("Round " +(i+1) +"\n");
                if(ingroupMoves[i]==null){
                    this.textAreasArray[groupIndx].append("This group played no moves in this round\n");
                }
                else{
                    for(int j=0; j<ingroupMoves[i].length-1; j++){
                        if(ingroupMoves[i][j]!=null){
                            this.textAreasArray[groupIndx].append("Player No."+ingroupMoves[i][j].getPlayerIndx()+"\n");
                            if(ingroupMoves[i][j].getMove()!=null)
                                this.textAreasArray[groupIndx].append(ingroupMoves[i][j].getMove().getRule().output());
                            else this.textAreasArray[groupIndx].append("No Moves In this ROUND\n");
                        }
                    }
                    if(ingroupMoves[i][ingroupMoves[i].length-1]==null)
                        this.textAreasArray[groupIndx].append("The LEADER made no decision\n");
                    else{
                        this.textAreasArray[groupIndx].append("LEADER DECISION\n");
                        this.textAreasArray[groupIndx].append(ingroupMoves[i][ingroupMoves[i].length-1].getMove().getRule().output());
                    }
                }
            }
        }
    }
    protected void fillIngroupDialogue(InGroupMove[][] ingroupMoves, int groupIndx){
        if(ingroupMoves==null) this.ingroupDialogue[groupIndx]=null;
        else{
            this.ingroupDialogue[groupIndx] = new InGroupMove[ingroupMoves.length][];
            for(int i=0; i<ingroupMoves.length; i++){
                if(ingroupMoves[i]==null)
                    this.ingroupDialogue[groupIndx][i]=null;
                else{
                    for(int j=0; j<ingroupMoves[i].length; j++){
                        this.ingroupDialogue[groupIndx][i][j] = ingroupMoves[i][j];
                    }
                }
            }
        }
    }
    
}
