/*
 * GMUInterface.java
 *
 * Created on 03 September 2008, 15:38
 *
 * this is GMU interface class, provides basic Node to Move operations
 *
 *@author maya
 */

package GUIComponents;

public class GMUInterface {
    private ActiveGroupsList ActiveGroupsList;
    private HistoryLog historyLog;
    /**GMUInterface basic constructor*/
    public GMUInterface(ActiveGroupsList newActiveGroupsList,  HistoryLog newHistoryLog) {
        this.ActiveGroupsList = newActiveGroupsList;
        this.historyLog = newHistoryLog;
    }    
    
    //Methods
    /*Node to Move methods - set of methods that uses the history log to translate Arg Tree Nodes
     to moves*/
    /**translates a tree node to a move*/
    public Move treeNodeToMove(CompressedArgTreeNode node){        
        Move move = this.historyLog.findMove(node.getPlayer(), node.getParent(), node.getRound(), node.getLeafIndx());         
        return move;
    }
    /**translates the tree leafs to moves*/
    public Move[] leafsToMoves(CompressedArgTreeNode[] leafs){
        if(leafs!=null){
            Move [] nodeMoves = new Move[leafs.length];
            for(int i=0; i<leafs.length; i++){
               nodeMoves[i] = this.historyLog.findMove(leafs[i].getPlayer(), leafs[i].getParent(), leafs[i].getRound(), leafs[i].getLeafIndx()); 
            }            
            return nodeMoves;
        }
        else return null;
    }    
}

