/*
 * HistoryLogNode.java
 *
 * Created on 02 September 2008, 13:56
 *
 * encapuslates the history log nodes, these are the basic nodes in the history log
 * they store PISA game moves played by some player a against some player b in compressed way
 * @author maya
 */

package GUIComponents;

public class HistoryLogNode {
    private int type; //the move TYPE - should be a vaild MOVE TYPE
    private int round; //the round in which the move was played
    private RuleNode rule;//the content of the move (AR)
    private HistoryLogNode next;//the next move (played by a against b), if any
    
    /** Creates a new instance of HistoryLogNode */
    public HistoryLogNode(int moveType, int currentRound, RuleNode moveRule) {
        this.type = moveType;
        this.round = currentRound;
        this.rule = moveRule;
        this.next = null;
    }
    
    /*Setters & Getters*/
    protected int getType() {return this.type;}
    protected int getRound() {return this.round;}
    protected RuleNode getRule(){return this.rule;}
    protected HistoryLogNode next(){return this.next;}

    /*Methods*/
    /**set the next node in line*/
    protected void next(int moveType, int currentRound, RuleNode moveRule){
        this.next = new HistoryLogNode(moveType, currentRound, moveRule);}
    /**return true if the current node equals historyLogNode*/
    protected boolean equals(HistoryLogNode historyLogNode){
        if(RuleNode.equals(this.rule, historyLogNode.getRule()))
            return true;
        else
            return false;
    }
    /**return true if the current node semi equals historyLogNode*/
    protected boolean semiEquals(HistoryLogNode historyLogNode){
      if(RuleNode.semiEquals(this.rule, historyLogNode.getRule()))
            return true;
        else
            return false;   
    }    
    /**return a string representing the history node*/
    protected String getString(){
        String outputString;
        outputString = "Round = "+this.round + "\n";
        outputString += "Type = "+this.type + "\n";
        outputString += "Rule = "+this.rule.getString() + "\n";
        return outputString;
    }
}//End of the Class

