/*
 * Move.java
 *
 * Created on 02 September 2008, 13:06
 *
 * encapsulates the move played by players in PISA games
 * @author maya
 */

package GUIComponents;

public class Move {
    private int source; //the source player (player who played the move)
    private int target;//the targeted player (player who the move is played against)
    private int type;//speech act
    private RuleNode rule;//content
    private int leafIndx;//if move is leaf move it returns its leafs index;
    
    /** Creates a new instance of Move */  
     public Move(int moveSource, int moveTarget, int moveType, RuleNode moveRule, int Attackedleaf){
         this.source = moveSource;//1 for the first move
         this.target=moveTarget; //0 for the first move
         this.type = moveType;
         this.rule= moveRule;
         this.leafIndx = Attackedleaf;
    }
     
     /*Setters & Getters*/
     protected int getTarget(){return this.target;}
     protected int getSource(){return this.source;}
     protected int getType(){return this.type;}
     protected RuleNode getRule(){return this.rule;}
     protected double getConfidence(){return this.rule.getConfidence();}
     protected int getLeafIndx(){return this.leafIndx;}
     
     /*METHODS*/
     /**returns true if two moves targeted against the same player, have the same content*/
     protected static boolean collides(Move move1, Move move2){
         if(move1.getTarget()==move2.getTarget()){
             if(move1.getType()==move2.getType()){
                 if(RuleNode.equals(move1.getRule(), move2.getRule()))
                     return true;
                 else
                     return false;
             }
             else
                 return false;
         }
         else
             return false;
     }
     protected static boolean equals(Move move1, Move move2){
         if(move1==null) return false;
         if(move2==null) return false;
         if(move1.getSource()==move2.getSource()){
             if(move1.getTarget()==move2.getTarget()){
                 if(move1.getType()==move2.getType()){
                     if(RuleNode.equals(move1.getRule(), move2.getRule()))
                         return true;
                     else   return false;
                 }
                 else return false;
             }
             else return false;
         }
         else return false;
     }
     
}//End of the Class
