/*
 * PISAMainFrame.java
 *
 * Created on 05 September 2008, 13:52
 */

package GUIComponents;

//user packages
import javax.swing.*;
import javax.swing.tree.DefaultMutableTreeNode;
import java.io.File;


public class PISAMainFrame extends javax.swing.JFrame {
    private GameDictionary gameDictionary=null;
    private short[] currentCase=null;
    private DynamicCaseDialog customDialog;
    private Chairperson chairperson=null;
    private GroupPlayer[] players=null;    
    private Group[] groups=null;
    DefaultMutableTreeNode groupsRoot=null;
    /** Creates new form PISAMainFrame */
    public PISAMainFrame() {
        initComponents(); 
    }
       
    //MY TEMPORARY NAVIGATING CODE
    private void getGamesSettings(String maxTree, String maxPlayers, 
            String maxRound,String maxSkips){
        String messageString = "you have changed the game settings to the following: \n";
        messageString +="Maximum Tree Size: " + maxTree +"\n";
        messageString +="Maximum Number of Players: " + maxPlayers +"\n";
        messageString +="Maximum Number of Rounds: " + maxRound +"\n";
        messageString +="Maximum Number of Skips: " + maxSkips +"\n";
        nOutputjTextArea.append(messageString);
    }
    
    //MY CODE
    private void groupsTreeSetup(){
        //DefaultMutableTreeNode root = new DefaultMutableTreeNode("Groups");
        if(this.groups!=null){
            for(int i=0; i<this.groups.length; i++){
                String groupName = this.gameDictionary.link(groups[i].getGoal());
                DefaultMutableTreeNode groupNode = new DefaultMutableTreeNode(groupName);
                GroupPlayer[] groupPlayers = this.groups[i].getPlayers();
                for(int j=0; j<groupPlayers.length; j++){                    
                    int playerIndx = j+1;
                    String playerName = "Player" + playerIndx;                    
                    DefaultMutableTreeNode playerNode = new DefaultMutableTreeNode(playerName);
                    String fileString = groupPlayers[j].getDataFilePath();
                    DefaultMutableTreeNode fileNode = new DefaultMutableTreeNode(fileString);
                    DefaultMutableTreeNode strategyNode = new DefaultMutableTreeNode("Strategy");
                    String mode = groupPlayers[j].getStrategy().outputMode();
                    DefaultMutableTreeNode modeNode = new DefaultMutableTreeNode(mode);
                    String type=groupPlayers[j].getStrategy().outputType();
                    DefaultMutableTreeNode typeNode = new DefaultMutableTreeNode(type);
                    String smartness = groupPlayers[j].getStrategy().outputSmartness();
                    DefaultMutableTreeNode smartNode = new DefaultMutableTreeNode(smartness);
                    strategyNode.add(modeNode);
                    strategyNode.add(typeNode);
                    strategyNode.add(smartNode);
                    //SET PLAYER NODE
                    playerNode.add(fileNode);
                    playerNode.add(strategyNode);
                    //ADD PLAYER NODE
                    groupNode.add(playerNode);
                }
                this.groupsRoot.add(groupNode);
            }
        }
    }
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        addNewGroupjDialog = new javax.swing.JDialog();
        addPlayersjButton = new javax.swing.JButton();
        goaljLabel = new javax.swing.JLabel();
        jSeparator5 = new javax.swing.JSeparator();
        jScrollPane1 = new javax.swing.JScrollPane();
        groupsjTextArea = new javax.swing.JTextArea();
        jSeparator6 = new javax.swing.JSeparator();
        anotherGroupjButton = new javax.swing.JButton();
        doneGroupsjButton = new javax.swing.JButton();
        goalsjComboBox = new javax.swing.JComboBox();
        addNewPlayerjDialog = new javax.swing.JDialog();
        dataFilejLabel = new javax.swing.JLabel();
        insertDataFilejButton = new javax.swing.JButton();
        donePlayersjButton = new javax.swing.JButton();
        addAnotherPlayerjButton = new javax.swing.JButton();
        strategyjLabel = new javax.swing.JLabel();
        jSeparator1 = new javax.swing.JSeparator();
        strategyModejComboBox = new javax.swing.JComboBox();
        jLabel1 = new javax.swing.JLabel();
        strategyTypejLabel = new javax.swing.JLabel();
        strategyTypejComboBox = new javax.swing.JComboBox();
        smartnessjComboBox = new javax.swing.JComboBox();
        smartnessjLabel1 = new javax.swing.JLabel();
        jSeparator2 = new javax.swing.JSeparator();
        strategyOptionsjButton = new javax.swing.JButton();
        playerDatasetjLabel = new javax.swing.JLabel();
        playerGoaljLabel = new javax.swing.JLabel();
        supportjLabel = new javax.swing.JLabel();
        supportjTextField = new javax.swing.JTextField();
        strategyOptionsjDialog = new javax.swing.JDialog();
        gameModejLabel = new javax.swing.JLabel();
        strategyOptionsDonejButton = new javax.swing.JButton();
        gameModejComboBox = new javax.swing.JComboBox();
        agentProfilejLabel = new javax.swing.JLabel();
        agentProfilejComboBox = new javax.swing.JComboBox();
        jSeparator3 = new javax.swing.JSeparator();
        armOptionsjLabel = new javax.swing.JLabel();
        minConfjLabel = new javax.swing.JLabel();
        maxConfjLabel = new javax.swing.JLabel();
        distThresholdjLabel = new javax.swing.JLabel();
        upThresholdjLabel = new javax.swing.JLabel();
        maxLeveljLabel = new javax.swing.JLabel();
        consideredLevelsjLabel = new javax.swing.JLabel();
        minConfjTextField = new javax.swing.JTextField();
        distThresholdjTextField = new javax.swing.JTextField();
        maxLevelsjTextField = new javax.swing.JTextField();
        maxConfjTextField = new javax.swing.JTextField();
        upThresholdjTextField = new javax.swing.JTextField();
        consideredLevelsjTextField = new javax.swing.JTextField();
        jSeparator4 = new javax.swing.JSeparator();
        gameSettingsjDialog = new javax.swing.JDialog();
        maxTreeSizejLabel = new javax.swing.JLabel();
        maxNoGroupsjLabel = new javax.swing.JLabel();
        maxTreeSizejTextField = new javax.swing.JTextField();
        maxNoGroupsjTextField = new javax.swing.JTextField();
        maxNoRoundsjLabel = new javax.swing.JLabel();
        maxNoRoundsjTextField = new javax.swing.JTextField();
        maxNoSkipsjLabel = new javax.swing.JLabel();
        maxNoSkipsjTextField = new javax.swing.JTextField();
        gsOKjButton = new javax.swing.JButton();
        gsDefaultjButton = new javax.swing.JButton();
        groupsDisplayjScrollPane = new javax.swing.JScrollPane();
        groupsDisplayjTree = new javax.swing.JTree();
        outputjTabbedPane = new javax.swing.JTabbedPane();
        dOutputjScrollPane = new javax.swing.JScrollPane();
        dOutputjTextArea = new javax.swing.JTextArea();
        hOutputjScrollPane = new javax.swing.JScrollPane();
        hOutputjTextArea = new javax.swing.JTextArea();
        tOutputjScrollPane = new javax.swing.JScrollPane();
        tOutputjTree = new javax.swing.JTree();
        gdOutputjTextArea = new javax.swing.JTextArea();
        nOutputjScrollPane = new javax.swing.JScrollPane();
        nOutputjTextArea = new javax.swing.JTextArea();
        pisaMainjMenuBar = new javax.swing.JMenuBar();
        gameSettingsjMenu = new javax.swing.JMenu();
        setGameDicjMenuItem = new javax.swing.JMenuItem();
        focusingLeveljMenu = new javax.swing.JMenu();
        level1jButtonMenuItem = new javax.swing.JRadioButtonMenuItem();
        level2jButtonMenuItem = new javax.swing.JRadioButtonMenuItem();
        level3jButtonMenuItem = new javax.swing.JRadioButtonMenuItem();
        level4jButtonMenuItem = new javax.swing.JRadioButtonMenuItem();
        menuGSjSeparator1 = new javax.swing.JSeparator();
        setGroupsjMenuItem = new javax.swing.JMenuItem();
        menuGSjSeparator2 = new javax.swing.JSeparator();
        gameOptionsjMenuItem = new javax.swing.JMenuItem();
        playGamejMenu = new javax.swing.JMenu();
        gameSetOptionjMenu = new javax.swing.JMenu();
        menuePGjSeparator1 = new javax.swing.JSeparator();
        playGamejMenuItem = new javax.swing.JMenuItem();
        resolveTiejMenuItem = new javax.swing.JMenuItem();
        menuePGjSeparator2 = new javax.swing.JSeparator();
        playAgainjMenuItem = new javax.swing.JMenuItem();
        optionsjMenu = new javax.swing.JMenu();
        outputHistoryjMenuItem = new javax.swing.JMenuItem();
        outputArgTreeMenuItem = new javax.swing.JMenuItem();
        outputInGroupsDialojMenuItem = new javax.swing.JMenuItem();

        addNewGroupjDialog.setTitle("Add New Group");
        addNewGroupjDialog.setName("addNewGroup"); // NOI18N

        addPlayersjButton.setText("Add Group Players");
        addPlayersjButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addPlayersjButtonActionPerformed(evt);
            }
        });

        goaljLabel.setText("Insert the Groups Goal");

        groupsjTextArea.setColumns(20);
        groupsjTextArea.setRows(5);
        groupsjTextArea.setText("GROUPS DETAILS:");
        jScrollPane1.setViewportView(groupsjTextArea);

        anotherGroupjButton.setText("Add another Group");
        anotherGroupjButton.setEnabled(false);
        anotherGroupjButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                anotherGroupjButtonActionPerformed(evt);
            }
        });

        doneGroupsjButton.setText("Done");
        doneGroupsjButton.setEnabled(false);
        doneGroupsjButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                doneGroupsjButtonActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout addNewGroupjDialogLayout = new org.jdesktop.layout.GroupLayout(addNewGroupjDialog.getContentPane());
        addNewGroupjDialog.getContentPane().setLayout(addNewGroupjDialogLayout);
        addNewGroupjDialogLayout.setHorizontalGroup(
            addNewGroupjDialogLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jSeparator5, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 408, Short.MAX_VALUE)
            .add(addNewGroupjDialogLayout.createSequentialGroup()
                .addContainerGap()
                .add(goaljLabel)
                .add(25, 25, 25)
                .add(goalsjComboBox, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 197, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(67, Short.MAX_VALUE))
            .add(addNewGroupjDialogLayout.createSequentialGroup()
                .addContainerGap()
                .add(addPlayersjButton)
                .addContainerGap(277, Short.MAX_VALUE))
            .add(org.jdesktop.layout.GroupLayout.TRAILING, addNewGroupjDialogLayout.createSequentialGroup()
                .addContainerGap()
                .add(anotherGroupjButton)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 206, Short.MAX_VALUE)
                .add(doneGroupsjButton)
                .addContainerGap())
            .add(jSeparator6, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 408, Short.MAX_VALUE)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, addNewGroupjDialogLayout.createSequentialGroup()
                .addContainerGap()
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 388, Short.MAX_VALUE)
                .addContainerGap())
        );
        addNewGroupjDialogLayout.setVerticalGroup(
            addNewGroupjDialogLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(addNewGroupjDialogLayout.createSequentialGroup()
                .addContainerGap()
                .add(addNewGroupjDialogLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(goaljLabel)
                    .add(goalsjComboBox, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(addPlayersjButton)
                .add(14, 14, 14)
                .add(jSeparator5, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 10, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 136, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jSeparator6, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 10, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(addNewGroupjDialogLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(doneGroupsjButton)
                    .add(anotherGroupjButton))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        addNewPlayerjDialog.setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        addNewPlayerjDialog.setTitle("Add New Player");
        addNewPlayerjDialog.setBackground(new java.awt.Color(204, 204, 255));

        dataFilejLabel.setText("Insert Player's Data File");

        insertDataFilejButton.setText("Insert Data File");
        insertDataFilejButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                insertDataFilejButtonActionPerformed(evt);
            }
        });

        donePlayersjButton.setText("Done");
        donePlayersjButton.setEnabled(false);
        donePlayersjButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                donePlayersjButtonActionPerformed(evt);
            }
        });

        addAnotherPlayerjButton.setText("Done and Add Another Player");
        addAnotherPlayerjButton.setEnabled(false);
        addAnotherPlayerjButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addAnotherPlayerjButtonActionPerformed(evt);
            }
        });

        strategyjLabel.setFont(new java.awt.Font("Tahoma", 1, 11));
        strategyjLabel.setText("Player's Strategy");

        strategyModejComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Build", "Destroy" }));
        strategyModejComboBox.setToolTipText("the strategy mode: build or destroy");

        jLabel1.setText("Strategy Mode");

        strategyTypejLabel.setText("Strategy Type");

        strategyTypejComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Attack When Possible", "Attack When Needed" }));

        smartnessjComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Blind", "Focused", "Tree Dependant" }));

        smartnessjLabel1.setText("Smartness");

        strategyOptionsjButton.setText("Advanced Options");

        playerDatasetjLabel.setForeground(new java.awt.Color(102, 102, 102));
        playerDatasetjLabel.setText("you have not chosen any dataset file yet");

        playerGoaljLabel.setFont(new java.awt.Font("Tahoma", 1, 11));
        playerGoaljLabel.setText("Player Goal is Empty");

        supportjLabel.setText("minimum support");

        supportjTextField.setText("0.1");
        supportjTextField.setEnabled(false);

        org.jdesktop.layout.GroupLayout addNewPlayerjDialogLayout = new org.jdesktop.layout.GroupLayout(addNewPlayerjDialog.getContentPane());
        addNewPlayerjDialog.getContentPane().setLayout(addNewPlayerjDialogLayout);
        addNewPlayerjDialogLayout.setHorizontalGroup(
            addNewPlayerjDialogLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(addNewPlayerjDialogLayout.createSequentialGroup()
                .addContainerGap()
                .add(addNewPlayerjDialogLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(addNewPlayerjDialogLayout.createSequentialGroup()
                        .add(addNewPlayerjDialogLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(addNewPlayerjDialogLayout.createSequentialGroup()
                                .add(strategyTypejLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 84, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(strategyTypejComboBox, 0, 230, Short.MAX_VALUE))
                            .add(addNewPlayerjDialogLayout.createSequentialGroup()
                                .add(jLabel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 84, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(strategyModejComboBox, 0, 230, Short.MAX_VALUE)))
                        .add(41, 41, 41)
                        .add(strategyOptionsjButton)
                        .addContainerGap())
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, addNewPlayerjDialogLayout.createSequentialGroup()
                        .add(addAnotherPlayerjButton)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 248, Short.MAX_VALUE)
                        .add(donePlayersjButton)
                        .addContainerGap())
                    .add(addNewPlayerjDialogLayout.createSequentialGroup()
                        .add(dataFilejLabel)
                        .add(16, 16, 16)
                        .add(addNewPlayerjDialogLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, supportjTextField)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, insertDataFilejButton, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .add(188, 188, 188))))
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jSeparator2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 500, Short.MAX_VALUE)
            .add(addNewPlayerjDialogLayout.createSequentialGroup()
                .addContainerGap()
                .add(strategyjLabel)
                .addContainerGap(392, Short.MAX_VALUE))
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jSeparator1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 500, Short.MAX_VALUE)
            .add(addNewPlayerjDialogLayout.createSequentialGroup()
                .addContainerGap()
                .add(playerDatasetjLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 480, Short.MAX_VALUE)
                .addContainerGap())
            .add(addNewPlayerjDialogLayout.createSequentialGroup()
                .addContainerGap()
                .add(playerGoaljLabel)
                .addContainerGap(375, Short.MAX_VALUE))
            .add(addNewPlayerjDialogLayout.createSequentialGroup()
                .addContainerGap()
                .add(supportjLabel)
                .addContainerGap(410, Short.MAX_VALUE))
            .add(addNewPlayerjDialogLayout.createSequentialGroup()
                .addContainerGap()
                .add(smartnessjLabel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 84, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(smartnessjComboBox, 0, 230, Short.MAX_VALUE)
                .add(172, 172, 172))
        );
        addNewPlayerjDialogLayout.setVerticalGroup(
            addNewPlayerjDialogLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(addNewPlayerjDialogLayout.createSequentialGroup()
                .add(playerGoaljLabel)
                .add(9, 9, 9)
                .add(addNewPlayerjDialogLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(dataFilejLabel)
                    .add(insertDataFilejButton))
                .add(14, 14, 14)
                .add(addNewPlayerjDialogLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(supportjLabel)
                    .add(supportjTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(playerDatasetjLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 38, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jSeparator1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 10, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(strategyjLabel)
                .add(22, 22, 22)
                .add(addNewPlayerjDialogLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel1)
                    .add(strategyModejComboBox, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(17, 17, 17)
                .add(addNewPlayerjDialogLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(strategyTypejLabel)
                    .add(strategyTypejComboBox, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(strategyOptionsjButton))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(addNewPlayerjDialogLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(smartnessjLabel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 23, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(smartnessjComboBox, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jSeparator2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 12, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(addNewPlayerjDialogLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(donePlayersjButton)
                    .add(addAnotherPlayerjButton))
                .addContainerGap())
        );

        strategyOptionsjDialog.setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        strategyOptionsjDialog.setTitle("Advanced Strategy Options");

        gameModejLabel.setText("Game Mode");

        strategyOptionsDonejButton.setText("Done");
        strategyOptionsDonejButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                strategyOptionsDonejButtonActionPerformed(evt);
            }
        });

        gameModejComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Game", "Win" }));

        agentProfilejLabel.setText("Player's Profile");

        agentProfilejComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Agreeable", "Disagreeable" }));

        armOptionsjLabel.setText("ARM Options");

        minConfjLabel.setText("Minimum Confidence");

        maxConfjLabel.setText("Maximum Confidence");

        distThresholdjLabel.setText("Distinguish Threshold");

        upThresholdjLabel.setText("Increase Threshold");

        maxLeveljLabel.setText("Maximum Tree Level");

        consideredLevelsjLabel.setText("Considered Levels");

        minConfjTextField.setText("55");

        distThresholdjTextField.setText("20");

        maxLevelsjTextField.setText("10");

        maxConfjTextField.setText("100");

        upThresholdjTextField.setText("60");

        consideredLevelsjTextField.setText("6");

        org.jdesktop.layout.GroupLayout strategyOptionsjDialogLayout = new org.jdesktop.layout.GroupLayout(strategyOptionsjDialog.getContentPane());
        strategyOptionsjDialog.getContentPane().setLayout(strategyOptionsjDialogLayout);
        strategyOptionsjDialogLayout.setHorizontalGroup(
            strategyOptionsjDialogLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jSeparator3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 441, Short.MAX_VALUE)
            .add(strategyOptionsjDialogLayout.createSequentialGroup()
                .addContainerGap()
                .add(armOptionsjLabel)
                .addContainerGap(369, Short.MAX_VALUE))
            .add(strategyOptionsjDialogLayout.createSequentialGroup()
                .addContainerGap()
                .add(strategyOptionsjDialogLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(agentProfilejLabel)
                    .add(gameModejLabel))
                .add(12, 12, 12)
                .add(strategyOptionsjDialogLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(agentProfilejComboBox, 0, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(gameModejComboBox, 0, 126, Short.MAX_VALUE))
                .addContainerGap(223, Short.MAX_VALUE))
            .add(strategyOptionsjDialogLayout.createSequentialGroup()
                .addContainerGap()
                .add(strategyOptionsjDialogLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(minConfjLabel)
                    .add(distThresholdjLabel)
                    .add(maxLeveljLabel))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(strategyOptionsjDialogLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(minConfjTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 81, Short.MAX_VALUE)
                    .add(maxLevelsjTextField)
                    .add(distThresholdjTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 73, Short.MAX_VALUE))
                .add(28, 28, 28)
                .add(strategyOptionsjDialogLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(maxConfjLabel)
                    .add(upThresholdjLabel)
                    .add(consideredLevelsjLabel))
                .add(14, 14, 14)
                .add(strategyOptionsjDialogLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(maxConfjTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 72, Short.MAX_VALUE)
                    .add(upThresholdjTextField)
                    .add(consideredLevelsjTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 82, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(20, Short.MAX_VALUE))
            .add(org.jdesktop.layout.GroupLayout.TRAILING, strategyOptionsjDialogLayout.createSequentialGroup()
                .addContainerGap(374, Short.MAX_VALUE)
                .add(strategyOptionsDonejButton)
                .addContainerGap())
            .add(jSeparator4, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 441, Short.MAX_VALUE)
        );
        strategyOptionsjDialogLayout.setVerticalGroup(
            strategyOptionsjDialogLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(strategyOptionsjDialogLayout.createSequentialGroup()
                .addContainerGap()
                .add(strategyOptionsjDialogLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(gameModejLabel)
                    .add(gameModejComboBox, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(strategyOptionsjDialogLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(agentProfilejLabel)
                    .add(agentProfilejComboBox, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(14, 14, 14)
                .add(jSeparator3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 10, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(strategyOptionsjDialogLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(strategyOptionsjDialogLayout.createSequentialGroup()
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(armOptionsjLabel)
                        .add(15, 15, 15)
                        .add(strategyOptionsjDialogLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(minConfjLabel)
                            .add(minConfjTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .add(22, 22, 22)
                        .add(strategyOptionsjDialogLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(distThresholdjLabel)
                            .add(distThresholdjTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .add(26, 26, 26)
                        .add(strategyOptionsjDialogLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(maxLeveljLabel)
                            .add(maxLevelsjTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                    .add(strategyOptionsjDialogLayout.createSequentialGroup()
                        .add(34, 34, 34)
                        .add(strategyOptionsjDialogLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(maxConfjLabel)
                            .add(maxConfjTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .add(22, 22, 22)
                        .add(strategyOptionsjDialogLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(upThresholdjLabel)
                            .add(upThresholdjTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .add(26, 26, 26)
                        .add(strategyOptionsjDialogLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(consideredLevelsjLabel)
                            .add(consideredLevelsjTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))))
                .add(8, 8, 8)
                .add(jSeparator4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 10, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(strategyOptionsDonejButton)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        gameSettingsjDialog.setTitle("Game Settings");

        maxTreeSizejLabel.setText("Maximum Tree Size");

        maxNoGroupsjLabel.setText("Maximum Number of Groups");

        maxNoRoundsjLabel.setText("Maximum Number of Rounds");

        maxNoSkipsjLabel.setText("Maximum Number of Skips");

        gsOKjButton.setText("OK");
        gsOKjButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                gsOKjButtonActionPerformed(evt);
            }
        });

        gsDefaultjButton.setText("Default Values");
        gsDefaultjButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                gsDefaultjButtonActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout gameSettingsjDialogLayout = new org.jdesktop.layout.GroupLayout(gameSettingsjDialog.getContentPane());
        gameSettingsjDialog.getContentPane().setLayout(gameSettingsjDialogLayout);
        gameSettingsjDialogLayout.setHorizontalGroup(
            gameSettingsjDialogLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(gameSettingsjDialogLayout.createSequentialGroup()
                .addContainerGap()
                .add(gameSettingsjDialogLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(gameSettingsjDialogLayout.createSequentialGroup()
                        .add(gsOKjButton)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 57, Short.MAX_VALUE)
                        .add(gsDefaultjButton))
                    .add(gameSettingsjDialogLayout.createSequentialGroup()
                        .add(gameSettingsjDialogLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(maxTreeSizejLabel)
                            .add(maxNoGroupsjLabel)
                            .add(maxNoRoundsjLabel)
                            .add(maxNoSkipsjLabel))
                        .add(19, 19, 19)
                        .add(gameSettingsjDialogLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(maxNoSkipsjTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 50, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.TRAILING, maxNoRoundsjTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 50, Short.MAX_VALUE)
                            .add(maxNoGroupsjTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 50, Short.MAX_VALUE)
                            .add(maxTreeSizejTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 50, Short.MAX_VALUE))))
                .addContainerGap())
        );
        gameSettingsjDialogLayout.setVerticalGroup(
            gameSettingsjDialogLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(gameSettingsjDialogLayout.createSequentialGroup()
                .addContainerGap()
                .add(gameSettingsjDialogLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(maxTreeSizejLabel)
                    .add(maxTreeSizejTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(17, 17, 17)
                .add(gameSettingsjDialogLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(maxNoGroupsjLabel)
                    .add(maxNoGroupsjTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(19, 19, 19)
                .add(gameSettingsjDialogLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(maxNoRoundsjLabel)
                    .add(maxNoRoundsjTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(16, 16, 16)
                .add(gameSettingsjDialogLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(maxNoSkipsjLabel)
                    .add(maxNoSkipsjTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(24, 24, 24)
                .add(gameSettingsjDialogLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(gsOKjButton)
                    .add(gsDefaultjButton))
                .addContainerGap())
        );

        maxTreeSizejTextField.getAccessibleContext().setAccessibleParent(gameSettingsjDialog);
        maxNoGroupsjTextField.getAccessibleContext().setAccessibleParent(gameSettingsjDialog);
        maxNoRoundsjTextField.getAccessibleContext().setAccessibleParent(gameSettingsjDialog);
        maxNoSkipsjTextField.getAccessibleContext().setAccessibleParent(gameSettingsjDialog);
        gsOKjButton.getAccessibleContext().setAccessibleParent(gameSettingsjDialog);
        gsDefaultjButton.getAccessibleContext().setAccessibleParent(gameSettingsjDialog);

        gameSettingsjDialog.getAccessibleContext().setAccessibleParent(this);

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("PISA GUI");
        setBackground(new java.awt.Color(204, 204, 255));

        groupsRoot = new DefaultMutableTreeNode("Groups");
        groupsDisplayjTree = new JTree(groupsRoot);
        groupsDisplayjTree.setBackground(new java.awt.Color(229, 229, 244));
        groupsDisplayjScrollPane.setViewportView(groupsDisplayjTree);

        outputjTabbedPane.setBackground(new java.awt.Color(204, 204, 255));
        outputjTabbedPane.setEnabled(false);

        dOutputjTextArea.setBackground(new java.awt.Color(229, 229, 244));
        dOutputjTextArea.setColumns(20);
        dOutputjTextArea.setRows(5);
        dOutputjTextArea.setText("dialogue output: empty - no game has been played yet");
        dOutputjScrollPane.setViewportView(dOutputjTextArea);

        outputjTabbedPane.addTab("tab1", dOutputjScrollPane);

        hOutputjTextArea.setBackground(new java.awt.Color(229, 229, 244));
        hOutputjTextArea.setColumns(20);
        hOutputjTextArea.setRows(5);
        hOutputjTextArea.setText("game history output: empty - no game has been played yet");
        hOutputjScrollPane.setViewportView(hOutputjTextArea);

        outputjTabbedPane.addTab("tab2", hOutputjScrollPane);

        tOutputjTree.setBackground(new java.awt.Color(229, 229, 244));
        tOutputjScrollPane.setViewportView(tOutputjTree);

        outputjTabbedPane.addTab("tab3", tOutputjScrollPane);

        gdOutputjTextArea.setBackground(new java.awt.Color(229, 229, 244));
        gdOutputjTextArea.setColumns(20);
        gdOutputjTextArea.setRows(5);
        gdOutputjTextArea.setText("Inter Groups Dialogs are empty, no game has been played yet");
        outputjTabbedPane.addTab("tab4", gdOutputjTextArea);

        nOutputjTextArea.setBackground(new java.awt.Color(229, 229, 244));
        nOutputjTextArea.setColumns(20);
        nOutputjTextArea.setRows(5);
        nOutputjTextArea.setText("Game Can Not Be Started Yet: \nYOU HAVE NOT UPLOADED ANY GAME DICTIONARY, or Selected Focusing Level!!!");
        nOutputjScrollPane.setViewportView(nOutputjTextArea);

        pisaMainjMenuBar.setBackground(new java.awt.Color(204, 204, 255));
        pisaMainjMenuBar.setNextFocusableComponent(gameSettingsjMenu);

        gameSettingsjMenu.setBackground(new java.awt.Color(204, 204, 255));
        gameSettingsjMenu.setForeground(new java.awt.Color(102, 102, 102));
        gameSettingsjMenu.setText("Set a New Game");

        setGameDicjMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_D, java.awt.event.InputEvent.CTRL_MASK));
        setGameDicjMenuItem.setBackground(new java.awt.Color(229, 229, 244));
        setGameDicjMenuItem.setForeground(new java.awt.Color(102, 102, 102));
        setGameDicjMenuItem.setText("Load Game Dictionary");
        setGameDicjMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                setGameDicjMenuItemActionPerformed(evt);
            }
        });
        gameSettingsjMenu.add(setGameDicjMenuItem);
        setGameDicjMenuItem.getAccessibleContext().setAccessibleName("setGameMan");

        ButtonGroup group2 = new ButtonGroup();
        group2.add(level1jButtonMenuItem);
        group2.add(level2jButtonMenuItem);
        group2.add(level3jButtonMenuItem);
        group2.add(level4jButtonMenuItem);
        focusingLeveljMenu.setBackground(new java.awt.Color(229, 229, 244));
        focusingLeveljMenu.setForeground(new java.awt.Color(102, 102, 102));
        focusingLeveljMenu.setText("Focusing Level");

        level1jButtonMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_U, java.awt.event.InputEvent.ALT_MASK | java.awt.event.InputEvent.CTRL_MASK));
        level1jButtonMenuItem.setBackground(new java.awt.Color(229, 229, 244));
        level1jButtonMenuItem.setForeground(new java.awt.Color(102, 102, 102));
        level1jButtonMenuItem.setText("Unfocused Games");
        level1jButtonMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                level1jButtonMenuItemActionPerformed(evt);
            }
        });
        focusingLeveljMenu.add(level1jButtonMenuItem);

        level2jButtonMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_F, java.awt.event.InputEvent.ALT_MASK | java.awt.event.InputEvent.CTRL_MASK));
        level2jButtonMenuItem.setBackground(new java.awt.Color(229, 229, 244));
        level2jButtonMenuItem.setForeground(new java.awt.Color(102, 102, 102));
        level2jButtonMenuItem.setText("Focused Games");
        level2jButtonMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                level2jButtonMenuItemActionPerformed(evt);
            }
        });
        focusingLeveljMenu.add(level2jButtonMenuItem);

        level3jButtonMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_S, java.awt.event.InputEvent.ALT_MASK | java.awt.event.InputEvent.CTRL_MASK));
        level3jButtonMenuItem.setBackground(new java.awt.Color(229, 229, 244));
        level3jButtonMenuItem.setForeground(new java.awt.Color(102, 102, 102));
        level3jButtonMenuItem.setText("Strictly Focused Games");
        level3jButtonMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                level3jButtonMenuItemActionPerformed(evt);
            }
        });
        focusingLeveljMenu.add(level3jButtonMenuItem);

        level4jButtonMenuItem.setBackground(new java.awt.Color(229, 229, 244));
        level4jButtonMenuItem.setForeground(new java.awt.Color(102, 102, 102));
        level4jButtonMenuItem.setText("Controlled Strictly Focused Games");
        level4jButtonMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                level4jButtonMenuItemActionPerformed(evt);
            }
        });
        focusingLeveljMenu.add(level4jButtonMenuItem);

        gameSettingsjMenu.add(focusingLeveljMenu);
        gameSettingsjMenu.add(menuGSjSeparator1);

        setGroupsjMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_G, java.awt.event.InputEvent.CTRL_MASK));
        setGroupsjMenuItem.setBackground(new java.awt.Color(229, 229, 244));
        setGroupsjMenuItem.setForeground(new java.awt.Color(102, 102, 102));
        setGroupsjMenuItem.setText("Set New Groups");
        setGroupsjMenuItem.setEnabled(false);
        setGroupsjMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                setGroupsjMenuItemActionPerformed(evt);
            }
        });
        gameSettingsjMenu.add(setGroupsjMenuItem);
        gameSettingsjMenu.add(menuGSjSeparator2);

        gameOptionsjMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_O, java.awt.event.InputEvent.CTRL_MASK));
        gameOptionsjMenuItem.setBackground(new java.awt.Color(229, 229, 244));
        gameOptionsjMenuItem.setForeground(new java.awt.Color(102, 102, 102));
        gameOptionsjMenuItem.setText("Change Game Options");
        gameOptionsjMenuItem.setEnabled(false);
        gameOptionsjMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                gameOptionsjMenuItemActionPerformed(evt);
            }
        });
        gameSettingsjMenu.add(gameOptionsjMenuItem);

        pisaMainjMenuBar.add(gameSettingsjMenu);

        playGamejMenu.setBackground(new java.awt.Color(204, 204, 255));
        playGamejMenu.setForeground(new java.awt.Color(102, 102, 102));
        playGamejMenu.setText("Play Game");
        playGamejMenu.setEnabled(false);
        playGamejMenu.setNextFocusableComponent(optionsjMenu);

        gameSetOptionjMenu.setBackground(new java.awt.Color(229, 229, 244));
        gameSetOptionjMenu.setForeground(new java.awt.Color(102, 102, 102));
        gameSetOptionjMenu.setText("Load Cases");
        gameSetOptionjMenu.setFocusCycleRoot(true);
        gameSetOptionjMenu.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                gameSetOptionjMenuActionPerformed(evt);
            }
        });
        playGamejMenu.add(gameSetOptionjMenu);
        playGamejMenu.add(menuePGjSeparator1);

        playGamejMenuItem.setBackground(new java.awt.Color(229, 229, 244));
        playGamejMenuItem.setForeground(new java.awt.Color(102, 102, 102));
        playGamejMenuItem.setText("Play Game/Game Set");
        playGamejMenuItem.setEnabled(false);
        playGamejMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                playGamejMenuItemActionPerformed(evt);
            }
        });
        playGamejMenu.add(playGamejMenuItem);

        resolveTiejMenuItem.setBackground(new java.awt.Color(229, 229, 244));
        resolveTiejMenuItem.setForeground(new java.awt.Color(102, 102, 102));
        resolveTiejMenuItem.setText("Resolve Tie");
        resolveTiejMenuItem.setEnabled(false);
        playGamejMenu.add(resolveTiejMenuItem);
        playGamejMenu.add(menuePGjSeparator2);

        playAgainjMenuItem.setBackground(new java.awt.Color(229, 229, 244));
        playAgainjMenuItem.setForeground(new java.awt.Color(102, 102, 102));
        playAgainjMenuItem.setText("Play Again");
        playAgainjMenuItem.setEnabled(false);
        playGamejMenu.add(playAgainjMenuItem);

        pisaMainjMenuBar.add(playGamejMenu);

        optionsjMenu.setBackground(new java.awt.Color(229, 229, 244));
        optionsjMenu.setForeground(new java.awt.Color(102, 102, 102));
        optionsjMenu.setText("Options");
        optionsjMenu.setContentAreaFilled(false);
        optionsjMenu.setNextFocusableComponent(gameSettingsjMenu);

        outputHistoryjMenuItem.setBackground(new java.awt.Color(229, 229, 244));
        outputHistoryjMenuItem.setForeground(new java.awt.Color(102, 102, 102));
        outputHistoryjMenuItem.setText("Output Game History");
        outputHistoryjMenuItem.setContentAreaFilled(false);
        outputHistoryjMenuItem.setEnabled(false);
        optionsjMenu.add(outputHistoryjMenuItem);

        outputArgTreeMenuItem.setBackground(new java.awt.Color(229, 229, 244));
        outputArgTreeMenuItem.setForeground(new java.awt.Color(102, 102, 102));
        outputArgTreeMenuItem.setText("Output Argumentation Tree");
        outputArgTreeMenuItem.setContentAreaFilled(false);
        outputArgTreeMenuItem.setEnabled(false);
        optionsjMenu.add(outputArgTreeMenuItem);

        outputInGroupsDialojMenuItem.setBackground(new java.awt.Color(229, 229, 244));
        outputInGroupsDialojMenuItem.setForeground(new java.awt.Color(102, 102, 102));
        outputInGroupsDialojMenuItem.setText("Output Groups Inner Dialogs (leader decisions)");
        outputInGroupsDialojMenuItem.setContentAreaFilled(false);
        optionsjMenu.add(outputInGroupsDialojMenuItem);

        pisaMainjMenuBar.add(optionsjMenu);

        setJMenuBar(pisaMainjMenuBar);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(groupsDisplayjScrollPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 217, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(nOutputjScrollPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 673, Short.MAX_VALUE)
                    .add(outputjTabbedPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 673, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(groupsDisplayjScrollPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 388, Short.MAX_VALUE)
                    .add(layout.createSequentialGroup()
                        .add(nOutputjScrollPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 163, Short.MAX_VALUE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(outputjTabbedPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 219, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void outputInGroupsDialojMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_outputInGroupsDialojMenuItemActionPerformed
        String[] classes = this.gameDictionary.getClasses();
        DynamicInGroupDialog inGroupDialog= new DynamicInGroupDialog(this, classes);
        for(int i=0; i<classes.length; i++){
            InGroupMove[][] ingroupMoves = this.chairperson.inGroupMoves(i);
            inGroupDialog.outputIngroupDialogue(ingroupMoves,i);
        }
        inGroupDialog.setSize(500,500);
        inGroupDialog.show();
    }//GEN-LAST:event_outputInGroupsDialojMenuItemActionPerformed

    private void playGamejMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_playGamejMenuItemActionPerformed
        // first get the case
        this.setCurrentCase();            
        //then play the game
        short[] classifications = this.gameDictionary.getClassesAttributes();
        this.chairperson.initializeGame(classifications,this.currentCase);
        this.chairperson.startGame();
        this.chairperson.playGame();
        //then output the game
        this.outputGroupMoves();
        this.dOutputjTextArea.append(this.chairperson.announceWinner());
    }//GEN-LAST:event_playGamejMenuItemActionPerformed

    private void outputGroupMoves(){
        Move[][] groupMoves= this.chairperson.getGUIMovesOutput();
        if(groupMoves==null){
            this.dOutputjTextArea.setText("Dialogue failed, no groups added any moves");
        }
        else{
            this.dOutputjTextArea.setText("");
            this.dOutputjTextArea.append("First Round\n");
            if(groupMoves[0]==null)
                this.dOutputjTextArea.append("No First Move Has Been Played");
            else
                this.dOutputjTextArea.append(this.outputFirstMove(groupMoves[0][0]));
            for(int i=1; i<groupMoves.length; i++){
                int roundNo = i+1;
                this.dOutputjTextArea.append("Round : " + roundNo + "\n");
                if(groupMoves[i]==null){
                    this.dOutputjTextArea.append("No Moves Have Been Played");
                }
                else{
                    for(int j=0; j<groupMoves[i].length; j++){
                       this.dOutputjTextArea.append(this.outputMove(groupMoves[i][j]));
                    }
                }
            }
        }
    }    
    private String outputFirstMove(Move move){       
        String output;
        if(move!=null){            
            short sourceGroupGoal = this.chairperson.getGroupGoal(move.getSource());
            String groupGoal = this.gameDictionary.link(sourceGroupGoal);
            output = "Group  - " + groupGoal +"\n";
            output+="First Move\n";
            output+=move.getRule().output();
        }
        else
            output = "first move is empty - no group has played a first move\n";
        return output;
    }
    protected String outputMove(Move move){       
        if(move!=null){
            short sourceGroupGoal = this.chairperson.getGroupGoal(move.getSource());
            String groupGoal = this.gameDictionary.link(sourceGroupGoal);
            String output = "Group  - " + groupGoal+"\n";
             switch(move.getType()){
                 case MoveType.PROPOSE_RULE:
                    output+="Propose rule\n"; 
                    break;
                 case MoveType.DISTINGUISH:
                    output+="Distinguish\n"; 
                    break;             
                 case MoveType.UNWANTED_CONSEQUENCES:
                    output+="Unwanted consequences\n"; 
                    break;              
                 case MoveType.COUNTER_RULE:
                    output+="Counter rule\n"; 
                    break;                    
                 case MoveType.INCREASE_CONFIDENCE:
                    output+="Increase Confidence\n";  
                    break;                    
                 case MoveType.WITHDRAW_UNWANTED_CONSEQUENCES:
                    output+="Withdraw unwanted consequences\n";  
                    break;                    
             }
             output+=move.getRule().output();
             return output;
        }
        else
            return "Move is empty\n";
    }
    private void setCurrentCase(){
        if(this.customDialog==null){
            JOptionPane.showMessageDialog(addNewPlayerjDialog,
                    "Please insert a CASE or a CASES FILE!!!.",
                    "Inane error",JOptionPane.ERROR_MESSAGE);
        }
        else{
            String[] customDialogCase = this.customDialog.getCurrentCase();
            if(customDialogCase==null){
                JOptionPane.showMessageDialog(addNewPlayerjDialog,
                    "CURRENT CASE IS NULL!!! Please inset a case.",
                    "Inane error",JOptionPane.ERROR_MESSAGE);
            }
            else{//the actual set case code
                //this.currentCase = new short[customDialogCase.length];
                this.currentCase = this.gameDictionary.linkCase(customDialogCase);
                /*for(int i=0; i<customDialogCase.length; i++){
                    this.currentCase[i] = this.gameDictionary.link(customDialogCase[i]);
                }*/
            }
        }
    }
    private void doneGroupsjButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_doneGroupsjButtonActionPerformed
     
        if((this.groups==null)||(this.groups.length!=this.gameDictionary.getClassesNumber())){
             JOptionPane.showMessageDialog(addNewGroupjDialog,
                    "Please add a number of groups equal to the number of classfications.",
                    "Inane error",JOptionPane.ERROR_MESSAGE);
        }
        else{
           this.addNewGroupjDialog.hide(); 
           this.setGroupsjMenuItem.setEnabled(false);
           this.playGamejMenu.setEnabled(true);
           for(int i=0; i<this.groups.length; i++){
               this.chairperson.addNewGroup(groups[i]);
           }
           this.groupsTreeSetup();
           this.setGameDicjMenuItem.setEnabled(false);
           this.focusingLeveljMenu.setEnabled(false);
           this.setGroupsjMenuItem.setEnabled(false);
        }        
    }//GEN-LAST:event_doneGroupsjButtonActionPerformed

    private void addAnotherPlayerjButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addAnotherPlayerjButtonActionPerformed
        /*when this action is performed we need to create a group player 
         set the goal/counter goals/dataFile/and strategy options then display
         adds it to players array then display this array on the groups display area*/
        if(!Checker.doubleValue(this.supportjTextField.getText()))
            JOptionPane.showMessageDialog(addNewPlayerjDialog,
                    "Please Insert VALID INTEGER DOUBLE VALUE in the minimum support textfiled.",
                    "Inane error",JOptionPane.ERROR_MESSAGE);
        else{
            short goal = this.gameDictionary.link(this.playerGoaljLabel.getText(),"CLASS");
            if(goal!=-1){
                short[] counterGoals = this.chairperson.getCounterGoals(goal);
                String dataFile = this.playerDatasetjLabel.getText();
                if(!((dataFile.equalsIgnoreCase("you have not chosen any dataset file yet"))||
                        (dataFile.equalsIgnoreCase("invalid file, please select again")))){
                    double minSupport = Double.parseDouble(this.supportjTextField.getText());
                    GroupPlayer newPlayer = new GroupPlayer(dataFile, goal, counterGoals, minSupport);
                    //setPlayer
                    newPlayer.setSmartnessLevel(this.smartnessjComboBox.getSelectedIndex()+1);
                    newPlayer.setStrategyType(this.strategyTypejComboBox.getSelectedIndex()+1);
                    newPlayer.setStrategyMode(this.strategyModejComboBox.getSelectedIndex()+1);
                    this.players = BasicOperations.append(this.players, newPlayer);
                    this.insertDataFilejButton.setText("Insert Data File");
                    this.supportjTextField.setText("0.1");
                    //this.supportjTextField.setEditable(false);
                    this.addAnotherPlayerjButton.setEnabled(false);
                    this.donePlayersjButton.setEnabled(false); 
                    this.playerDatasetjLabel.setText("you have not chosen any dataset file yet");
                }                                
            }
            else{
                JOptionPane.showMessageDialog(addNewPlayerjDialog,
                    "Please check the GAME DICTIONARY FILE for ERRORS.",
                    "Inane error",JOptionPane.ERROR_MESSAGE);
            }
        }
    }//GEN-LAST:event_addAnotherPlayerjButtonActionPerformed
    private void outputPlayerParameters(){
        if(this.players!=null){
            for(int i=0; i<this.players.length; i++){
                this.groupsjTextArea.append(players[i].outputParameters());
            }
        }
    }
    private void donePlayersjButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_donePlayersjButtonActionPerformed
        /*when this action is performed we need to create a group player 
         set the goal/counter goals/dataFile/and strategy options then display
         adds it to players array then display this array on the groups display area*/
        if(!Checker.doubleValue(this.supportjTextField.getText())){
            JOptionPane.showMessageDialog(addNewPlayerjDialog,
                    "Please Insert VALID INTEGER DOUBLE VALUE in the minimum support textfiled.",
                    "Inane error",JOptionPane.ERROR_MESSAGE);
        }
        else{
            short goal = this.gameDictionary.link(this.playerGoaljLabel.getText(),"CLASS");
            if(goal!=-1){
                short[] counterGoals = this.chairperson.getCounterGoals(goal);
                String dataFile = this.playerDatasetjLabel.getText();
                if(!((dataFile.equalsIgnoreCase("you have not chosen any dataset file yet"))||
                        (dataFile.equalsIgnoreCase("invalid file, please select again")))){
                    double minSupport = Double.parseDouble(this.supportjTextField.getText());
                    GroupPlayer newPlayer = new GroupPlayer(dataFile, goal, counterGoals, minSupport);
                    newPlayer.setSmartnessLevel(this.smartnessjComboBox.getSelectedIndex()+1);
                    newPlayer.setStrategyType(this.strategyTypejComboBox.getSelectedIndex()+1);
                    newPlayer.setStrategyMode(this.strategyModejComboBox.getSelectedIndex()+1);
                    this.players = BasicOperations.append(this.players, newPlayer);
                    this.insertDataFilejButton.setText("Insert Data File");
                    this.supportjTextField.setText("0.1");
                    //this.supportjTextField.setEditable(false);
                    this.addAnotherPlayerjButton.setEnabled(false);
                    this.donePlayersjButton.setEnabled(false);                    
                    this.addNewPlayerjDialog.hide();
                    /*write the new players information on the groups text area*/
                    this.outputPlayerParameters();
                    this.anotherGroupjButton.setEnabled(true);
                    this.playerDatasetjLabel.setText("you have not chosen any dataset file yet");
                }                                
            }
            else{
                JOptionPane.showMessageDialog(addNewPlayerjDialog,
                    "Please check the GAME DICTIONARY FILE for ERRORS.",
                    "Inane error",JOptionPane.ERROR_MESSAGE);
            }
        }
    }//GEN-LAST:event_donePlayersjButtonActionPerformed

    private void level4jButtonMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_level4jButtonMenuItemActionPerformed
        this.chairperson = new Chairperson(3);
        this.focusingLeveljMenu.setText("Controlled Strictly Focused Level was chosen");
        this.focusingLeveljMenu.setEnabled(false);                
        this.gameOptionsjMenuItem.setEnabled(true);
        if (this.gameDictionary!=null){
            this.setGroupsjMenuItem.setEnabled(true);
            this.nOutputjTextArea.append("\nYOU CAN START LOADING GROUPS NOW\n");
        }
        else
            this.nOutputjTextArea.setText("PLEASE LOAD A GAME DICTIONART TO START THE GAME\n");

    }//GEN-LAST:event_level4jButtonMenuItemActionPerformed

    private void level3jButtonMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_level3jButtonMenuItemActionPerformed
        this.chairperson = new Chairperson(2);
        this.focusingLeveljMenu.setText("Strictly Focused Level was chosen");
        this.focusingLeveljMenu.setEnabled(false);                
        this.gameOptionsjMenuItem.setEnabled(true);
        if (this.gameDictionary!=null){
            this.setGroupsjMenuItem.setEnabled(true);
            this.nOutputjTextArea.append("\nYOU CAN START LOADING GROUPS NOW\n");
        }
        else
            this.nOutputjTextArea.setText("PLEASE LOAD A GAME DICTIONART TO START THE GAME\n");

    }//GEN-LAST:event_level3jButtonMenuItemActionPerformed

    private void level2jButtonMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_level2jButtonMenuItemActionPerformed
        this.chairperson = new Chairperson(1);
        this.focusingLeveljMenu.setText("Focused Level was chosen");
        this.focusingLeveljMenu.setEnabled(false);                
        this.gameOptionsjMenuItem.setEnabled(true);
        if (this.gameDictionary!=null){
            this.setGroupsjMenuItem.setEnabled(true);
            this.nOutputjTextArea.append("\nYOU CAN START LOADING GROUPS NOW\n");
        }
        else
            this.nOutputjTextArea.setText("PLEASE LOAD A GAME DICTIONART TO START THE GAME\n");

    }//GEN-LAST:event_level2jButtonMenuItemActionPerformed

    private void strategyOptionsDonejButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_strategyOptionsDonejButtonActionPerformed
        this.strategyOptionsjDialog.hide();
    }//GEN-LAST:event_strategyOptionsDonejButtonActionPerformed

    private void level1jButtonMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_level1jButtonMenuItemActionPerformed
        this.chairperson = new Chairperson();
        this.focusingLeveljMenu.setText("Unfocused Level was chosen");
        this.focusingLeveljMenu.setEnabled(false);                
        this.gameOptionsjMenuItem.setEnabled(true);
        if (this.gameDictionary!=null){
            this.setGroupsjMenuItem.setEnabled(true);
            this.nOutputjTextArea.append("\nYOU CAN START LOADING GROUPS NOW\n");
        }
        else
            this.nOutputjTextArea.setText("PLEASE LOAD A GAME DICTIONART TO START THE GAME\n");
    }//GEN-LAST:event_level1jButtonMenuItemActionPerformed

    private short[] translateCase(String[] input){
        /*short[] currentCase = new short[input.length];
        for(int i=0; i<input.length; i++){            
            this.currentCase[i] = this.gameDictionary.link(input[i]);
        }*/
        short[] currentCase = this.gameDictionary.linkCase(input);
        return currentCase;
    }
    private void outputCase(String[] stringCase){
        short[] currentCase= this.translateCase(stringCase);
        this.nOutputjTextArea.append("you have selected the following Case :\n");
        this.nOutputjTextArea.append("{ ");
        for(int i=0; i<currentCase.length; i++){
            this.nOutputjTextArea.append(stringCase[i] + "  ");            
        }
        this.nOutputjTextArea.append("}\n ");
        this.nOutputjTextArea.append("{ ");
        for(int i=0; i<currentCase.length; i++){
            this.nOutputjTextArea.append(currentCase[i] + "  ");            
        }
        this.nOutputjTextArea.append("}\n ");
    }
    private void insertDataFilejButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_insertDataFilejButtonActionPerformed
      
        JFileChooser chooser = new JFileChooser();        
        PISAFilter filter = new PISAFilter();
        filter.setValidExtension("num");
        chooser.setFileFilter(filter);
        chooser.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
        int returnVal = chooser.showOpenDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            File file = chooser.getSelectedFile();
            this.playerDatasetjLabel.setText(file.getPath());
            this.insertDataFilejButton.setText("Change Datafile");
            this.supportjTextField.setEnabled(true);
            this.addAnotherPlayerjButton.setEnabled(true);
            this.donePlayersjButton.setEnabled(true);
        }
        else{
            this.playerDatasetjLabel.setText("invalid file, please select again");
        }
    }//GEN-LAST:event_insertDataFilejButtonActionPerformed

    private void anotherGroupjButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_anotherGroupjButtonActionPerformed
        if(this.goalsjComboBox.getSelectedIndex()!=0){
            String selectedGoal = (String)this.goalsjComboBox.getSelectedItem();
            short goal = this.gameDictionary.link(selectedGoal,"CLASS");
            short[] counterGoals = this.chairperson.getCounterGoals(goal);
            /*create the group and add the players*/
            Group newGroup = new Group(goal, counterGoals, this.players);
            this.groups = BasicOperations.append(this.groups, newGroup);
            this.players=null;
            int selectedIndex = this.goalsjComboBox.getSelectedIndex();
            int itemCount = this.goalsjComboBox.getItemCount();          
            if(itemCount==2){
                String[] newList = {"no remaining goals"};
                this.goalsjComboBox.setModel(new javax.swing.DefaultComboBoxModel(newList));
                this.goalsjComboBox.setEnabled(false);
                this.anotherGroupjButton.setEnabled(false);
                this.doneGroupsjButton.setEnabled(true);
            }
            else{
                String[] newList = new String[itemCount-1];
                int index=0;
                for(int i=0; i<itemCount; i++){
                    if(i!=selectedIndex){
                        newList[index] = (String) this.goalsjComboBox.getItemAt(i);
                        index++;
                    }
                }
                this.goalsjComboBox.setModel(new javax.swing.DefaultComboBoxModel(newList));
                this.goalsjComboBox.setSelectedIndex(0);
                this.anotherGroupjButton.setEnabled(false);
            }
        }
    }//GEN-LAST:event_anotherGroupjButtonActionPerformed

    private void setGroupsjMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_setGroupsjMenuItemActionPerformed
        if(this.gameDictionary!=null){
            short[] classifications = this.gameDictionary.getClassesAttributes();
            this.chairperson.setClassifications(classifications);
            String [] optionsList = {"Please select a goal class"};          
            String[] classesList = this.gameDictionary.getClasses();
            optionsList = BasicOperations.append(optionsList,classesList);
            goalsjComboBox.setModel(new javax.swing.DefaultComboBoxModel(optionsList));
            goalsjComboBox.setSelectedIndex(0);
        }
        this.addNewGroupjDialog.setSize(600,400);
        this.addNewGroupjDialog.show();
    }//GEN-LAST:event_setGroupsjMenuItemActionPerformed

    private void gsDefaultjButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_gsDefaultjButtonActionPerformed
        int[] defaultValues = this.chairperson.getDefualtParameters();
        this.maxTreeSizejTextField.setText(String.valueOf(defaultValues[0]));
        this.maxNoRoundsjTextField.setText(String.valueOf(defaultValues[1]));
        this.maxNoGroupsjTextField.setText(String.valueOf(defaultValues[2]));
        this.maxNoSkipsjTextField.setText(String.valueOf(defaultValues[3]));
    }//GEN-LAST:event_gsDefaultjButtonActionPerformed

    private void gsOKjButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_gsOKjButtonActionPerformed

        if((!Checker.intValue(maxTreeSizejTextField.getText()))||
                (!Checker.intValue(maxNoRoundsjTextField.getText()))||
                (!Checker.intValue(maxNoGroupsjTextField.getText()))||
                (!Checker.intValue(maxNoSkipsjTextField.getText()))){
            JOptionPane.showMessageDialog(addNewGroupjDialog,
                    "Please Insert VALID INTEGER INTEGER VALUES in all the text field.",
                    "Inane error",JOptionPane.ERROR_MESSAGE);
        }
        else{
            int maxTreeSize = Integer.parseInt(this.maxTreeSizejTextField.getText());
            int maxNoRounds = Integer.parseInt(this.maxNoRoundsjTextField.getText());
            int maxNoGroups = Integer.parseInt(this.maxNoGroupsjTextField.getText());
            int maxNoSkips = Integer.parseInt(this.maxNoSkipsjTextField.getText());
            this.chairperson.setGameParameters(maxTreeSize, maxNoRounds, maxNoGroups, maxNoSkips);
            gameSettingsjDialog.hide();
        }
        
    }//GEN-LAST:event_gsOKjButtonActionPerformed

    private void gameOptionsjMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_gameOptionsjMenuItemActionPerformed
        gameSettingsjDialog.setSize(250,250);
        // [0] = maxTreeSize, [1]maxNoRounds [2]maxNoGroups [3]maxNoSkips
        int[] defaultValues = this.chairperson.getDefualtParameters();
        this.maxTreeSizejTextField.setText(String.valueOf(defaultValues[0]));
        this.maxNoRoundsjTextField.setText(String.valueOf(defaultValues[1]));
        this.maxNoGroupsjTextField.setText(String.valueOf(defaultValues[2]));
        this.maxNoSkipsjTextField.setText(String.valueOf(defaultValues[3]));
        gameSettingsjDialog.show();
    }//GEN-LAST:event_gameOptionsjMenuItemActionPerformed

    private void setGameDicjMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_setGameDicjMenuItemActionPerformed
        JFileChooser chooser = new JFileChooser();
        PISAFilter filter = new PISAFilter();
        
        chooser.setFileFilter(filter);
        int returnVal = chooser.showOpenDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            nOutputjTextArea.setText("you chose to open the following game dictionary file : " +
                    chooser.getSelectedFile().getName()+"\n");
            File file = chooser.getSelectedFile();
            this.gameDictionary = new GameDictionary(file);
            int translateReturn = this.gameDictionary.translate();
            switch(translateReturn){
                case -2: 
                    nOutputjTextArea.append("System failed to read the game dictionary file you choose\n");
                    break;
                case -3: 
                    nOutputjTextArea.append("System failed to process the game dictionary file you choose\n");
                    break;
                case 0:
                    nOutputjTextArea.append("the file you choose is in the right format\n");
                    nOutputjTextArea.append(this.gameDictionary.output());
                    break;
            }
            if(translateReturn==0){
                if(this.focusingLeveljMenu.isEnabled()){
                    nOutputjTextArea.append("\nCANT START THE GAME YET, PLEASE SELECT FOCUSING LEVEL\n");
                }
                else
                    setGroupsjMenuItem.setEnabled(true);
            }                
        }     
    }//GEN-LAST:event_setGameDicjMenuItemActionPerformed

    private void addPlayersjButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addPlayersjButtonActionPerformed
        this.groupsjTextArea.append("\nadding player to group : " + (String) this.goalsjComboBox.getSelectedItem() + "\n");
        String goalString = (String) this.goalsjComboBox.getSelectedItem();
        this.playerGoaljLabel.setText(goalString);
        this.addNewPlayerjDialog.setSize(450,400);
        this.addNewPlayerjDialog.show();
    }//GEN-LAST:event_addPlayersjButtonActionPerformed

    private void gameSetOptionjMenuActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_gameSetOptionjMenuActionPerformed
        // TODO add your handling code here:
        customDialog = new DynamicCaseDialog(this,this.gameDictionary);
        customDialog.pack();
        customDialog.setLocationRelativeTo(this);
        customDialog.setVisible(true);
    }//GEN-LAST:event_gameSetOptionjMenuActionPerformed
    
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new PISAMainFrame().setVisible(true);
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton addAnotherPlayerjButton;
    private javax.swing.JDialog addNewGroupjDialog;
    private javax.swing.JDialog addNewPlayerjDialog;
    private javax.swing.JButton addPlayersjButton;
    private javax.swing.JComboBox agentProfilejComboBox;
    private javax.swing.JLabel agentProfilejLabel;
    private javax.swing.JButton anotherGroupjButton;
    private javax.swing.JLabel armOptionsjLabel;
    private javax.swing.JLabel consideredLevelsjLabel;
    private javax.swing.JTextField consideredLevelsjTextField;
    private javax.swing.JScrollPane dOutputjScrollPane;
    private javax.swing.JTextArea dOutputjTextArea;
    private javax.swing.JLabel dataFilejLabel;
    private javax.swing.JLabel distThresholdjLabel;
    private javax.swing.JTextField distThresholdjTextField;
    private javax.swing.JButton doneGroupsjButton;
    private javax.swing.JButton donePlayersjButton;
    private javax.swing.JMenu focusingLeveljMenu;
    private javax.swing.JComboBox gameModejComboBox;
    private javax.swing.JLabel gameModejLabel;
    private javax.swing.JMenuItem gameOptionsjMenuItem;
    private javax.swing.JMenu gameSetOptionjMenu;
    private javax.swing.JDialog gameSettingsjDialog;
    private javax.swing.JMenu gameSettingsjMenu;
    private javax.swing.JTextArea gdOutputjTextArea;
    private javax.swing.JLabel goaljLabel;
    private javax.swing.JComboBox goalsjComboBox;
    private javax.swing.JScrollPane groupsDisplayjScrollPane;
    private javax.swing.JTree groupsDisplayjTree;
    private javax.swing.JTextArea groupsjTextArea;
    private javax.swing.JButton gsDefaultjButton;
    private javax.swing.JButton gsOKjButton;
    private javax.swing.JScrollPane hOutputjScrollPane;
    private javax.swing.JTextArea hOutputjTextArea;
    private javax.swing.JButton insertDataFilejButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSeparator jSeparator2;
    private javax.swing.JSeparator jSeparator3;
    private javax.swing.JSeparator jSeparator4;
    private javax.swing.JSeparator jSeparator5;
    private javax.swing.JSeparator jSeparator6;
    private javax.swing.JRadioButtonMenuItem level1jButtonMenuItem;
    private javax.swing.JRadioButtonMenuItem level2jButtonMenuItem;
    private javax.swing.JRadioButtonMenuItem level3jButtonMenuItem;
    private javax.swing.JRadioButtonMenuItem level4jButtonMenuItem;
    private javax.swing.JLabel maxConfjLabel;
    private javax.swing.JTextField maxConfjTextField;
    private javax.swing.JLabel maxLeveljLabel;
    private javax.swing.JTextField maxLevelsjTextField;
    private javax.swing.JLabel maxNoGroupsjLabel;
    private javax.swing.JTextField maxNoGroupsjTextField;
    private javax.swing.JLabel maxNoRoundsjLabel;
    private javax.swing.JTextField maxNoRoundsjTextField;
    private javax.swing.JLabel maxNoSkipsjLabel;
    private javax.swing.JTextField maxNoSkipsjTextField;
    private javax.swing.JLabel maxTreeSizejLabel;
    private javax.swing.JTextField maxTreeSizejTextField;
    private javax.swing.JSeparator menuGSjSeparator1;
    private javax.swing.JSeparator menuGSjSeparator2;
    private javax.swing.JSeparator menuePGjSeparator1;
    private javax.swing.JSeparator menuePGjSeparator2;
    private javax.swing.JLabel minConfjLabel;
    private javax.swing.JTextField minConfjTextField;
    private javax.swing.JScrollPane nOutputjScrollPane;
    private javax.swing.JTextArea nOutputjTextArea;
    private javax.swing.JMenu optionsjMenu;
    private javax.swing.JMenuItem outputArgTreeMenuItem;
    private javax.swing.JMenuItem outputHistoryjMenuItem;
    private javax.swing.JMenuItem outputInGroupsDialojMenuItem;
    private javax.swing.JTabbedPane outputjTabbedPane;
    private javax.swing.JMenuBar pisaMainjMenuBar;
    private javax.swing.JMenuItem playAgainjMenuItem;
    private javax.swing.JMenu playGamejMenu;
    private javax.swing.JMenuItem playGamejMenuItem;
    private javax.swing.JLabel playerDatasetjLabel;
    private javax.swing.JLabel playerGoaljLabel;
    private javax.swing.JMenuItem resolveTiejMenuItem;
    private javax.swing.JMenuItem setGameDicjMenuItem;
    private javax.swing.JMenuItem setGroupsjMenuItem;
    private javax.swing.JComboBox smartnessjComboBox;
    private javax.swing.JLabel smartnessjLabel1;
    private javax.swing.JComboBox strategyModejComboBox;
    private javax.swing.JButton strategyOptionsDonejButton;
    private javax.swing.JButton strategyOptionsjButton;
    private javax.swing.JDialog strategyOptionsjDialog;
    private javax.swing.JComboBox strategyTypejComboBox;
    private javax.swing.JLabel strategyTypejLabel;
    private javax.swing.JLabel strategyjLabel;
    private javax.swing.JLabel supportjLabel;
    private javax.swing.JTextField supportjTextField;
    private javax.swing.JScrollPane tOutputjScrollPane;
    private javax.swing.JTree tOutputjTree;
    private javax.swing.JLabel upThresholdjLabel;
    private javax.swing.JTextField upThresholdjTextField;
    // End of variables declaration//GEN-END:variables
    
}
