/*
 * StrategyConstants.java
 *
 * Created on 02 September 2008, 16:23
 *
 * Constants class, has all the constant values for PISA strategies
 * @author maya
 */

package GUIComponents;

public final class StrategyConstants {
    //GAME MODE
    protected static final int GAME_MODE_WIN=1;
    protected static final int GAME_MODE_GAME=2;
    //AGENT PROFILE
    protected static final int AGENT_PROFILE_DISAGREEABLE=1;
    protected static final int AGENT_PROFILE_AGREEABLE=2;
    //STRATEGY MODE
    protected static final int STRATEGY_MODE_BUILD=1;
    protected static final int STRATEGY_MODE_DESTROY=2;
    //STRATEGY TYPE
    protected static final int ATTACK_WHEN_POSSIBLE=1;
    protected static final int ATTACK_WHEN_NEEDED=2;
    protected static final int ATTACK_TO_PREVENT_THREAT=3;    
    //SMARTNESS
    protected static final int SMARTNESS_BLIND=1;
    protected static final int SMARTNESS_FOCUSED=2;
    protected static final int SMARTNESS_TREE_ORIENTED=3;
    
    //checkers
    protected static boolean checkGameMode(int gameMode){
        if((gameMode==GAME_MODE_GAME)||(gameMode==GAME_MODE_WIN))
            return true;
        else return false;
    }    
    protected static boolean checkAgentProfile(int profile){
        if((profile==AGENT_PROFILE_DISAGREEABLE)||(profile==AGENT_PROFILE_AGREEABLE))
            return true;
        else return false;
    }
    protected static boolean checkStrategyMode(int strategyMode){
        if((strategyMode==STRATEGY_MODE_BUILD)||(strategyMode==STRATEGY_MODE_DESTROY))
            return true;
        else return false;
    }
    protected static boolean checkStrategyType(int strategyType){
        if((strategyType==ATTACK_WHEN_POSSIBLE)||(strategyType==ATTACK_WHEN_NEEDED)
            ||(strategyType==ATTACK_TO_PREVENT_THREAT))
            return true;
        else return false;
    }
    protected static boolean checkSmartness(int smartness){
        if((smartness==SMARTNESS_BLIND)||(smartness==SMARTNESS_FOCUSED)
            ||(smartness==SMARTNESS_TREE_ORIENTED))
            return true;
        else return false;
    }
}
