/*
 * TMUInterface.java
 *
 * Created on 03 September 2008, 12:03
 *
 * Controls argumentation tree READ requests, 
 * provides players with limited access to the argumentation tree.
 * @author maya
 */

package GUIComponents;

public class TMUInterface {
    ArgTree argTree;
    int focusingLevel;
    
    //Constructor
    public TMUInterface(ArgTree newargTree) {
        this.argTree = newargTree;
        this.focusingLevel=0;
    }    
    public TMUInterface(ArgTree newargTree, int treeFocusingLevel) {
        this.argTree = newargTree;
        this.focusingLevel=treeFocusingLevel;
    }    
    /*Managing Requests from Tree Oriented Players*/
    //All Levels of Focusing Requests
    public double greenConf(){return this.argTree.getGreenConf();}
    public boolean greenConfStatus(){return this.argTree.greenConfStatus();}
    public int greenConfPlayer(){return this.argTree.greenConfplayer();}
    public double activeGreenConf(){return this.argTree.getActiveGreenConf();}
    public boolean activeGreenConfStatus(){return this.argTree.activeGreenConfStatus();}
    public int activeGreenNodePlayer(){return this.argTree.activeGreenNodePlayer();}
    
    //Methods that differ according to level of focusing
    public CompressedArgTreeNode[] requestCompressedLeafs(){
        return this.argTree.getCompressedLeafs(this.focusingLevel);
    }
    public CompressedArgTreeNode[] greenConfCompressedLeafs(){return this.argTree.greenConfCompressedLeafs(this.focusingLevel);}        
    public CompressedArgTreeNode[] activeGreenConfCompressedLeafs(){return this.argTree.activeGreenConfCompressedLeafs(this.focusingLevel);}
    public int[] countBlueNodes(){return this.argTree.countBlueNodes();}
    public CompressedArgTreeNode[] compressedIndirectThreats(int playerIndx){return this.argTree.compressedIndirectThreats(playerIndx, this.focusingLevel);}
    public boolean activeGreenEqualsGreenConf(){return this.argTree.activeGreenEqualsGreenConf();}
    public CompressedArgTreeNode highestConfLeaf(int playerIndx){return this.argTree.highestConfLeaf(playerIndx);}
    public boolean hasGreenNodes(int playerIndx){return this.argTree.hasGreenNodes(playerIndx);}
    public int dominantBlue(){return this.argTree.dominantBlue();}
    public CompressedArgTreeNode[] compressedPlayerLeafs(int playerIndx){return this.argTree.compressedPlayerLeafs(playerIndx,this.focusingLevel);}    
}
