/*
 * TestManager.java
 *
 * Created on 04 September 2008, 17:14
 *
 * provides the procedure needed for pisa empirical studies
 * processing large cases files, output the final results in the right format
 * does not out put the game moves
 *
 *@author maya
 */

package GUIComponents;
//java packages
import java.util.*;
import java.io.*;

public class TestManager {
    private String  inputFileName   = null;//input files paths  
    private BufferedReader fileInput;//The input stream.    
    private int[] rounds = null;//the number of rounds each test takes
    private int roundsIndx=0;
    private Chairperson chairperson= null;
    /** Creates a new instance of TestManager */
    public TestManager() {}    
    //BASIC METHODS
    private double roundsDeviation(){
        if(this.rounds !=null){
            double mean = this.mean(this.rounds);
            double a=0;
            for(int i=0; i<rounds.length; i++){
                double b = rounds[i] - mean;
		a += Math.pow( b,2);
            }
            double c = (double) a/rounds.length;
            return Math.sqrt(c);
        }
        else return 0;
    }
    private double mean(int[] a){
	if (a.length ==1) return a[0];
	else{
	  int sum=0;
	  for(int i=0; i<a.length; i++)
		sum+= a[i];
	  return (double) sum/a.length;
	}
  }
  
    /**translate data lines into cases format*/
    private short[] processCase(String caseLine ,int attributesNumber) {
        StringTokenizer caseTok = new StringTokenizer(caseLine);
        short number;
        short[] newCase = new short[attributesNumber];
        // Load array
        for (int tokenCounter=0;tokenCounter < attributesNumber;tokenCounter++) {
            number = new Short(caseTok.nextToken()).shortValue();
	    newCase[tokenCounter] = number;
        }
        return(newCase);
    }
    /***/
    protected void playGamesSet(String caseFile, String testName, short[] classifications, int correctClass, int cases, int gameType){
        int correct =0;
        this.rounds = new int[cases];
        this.roundsIndx=0;
        try{
            FileReader file = new FileReader(caseFile);
            fileInput = new BufferedReader(file);
            String caseLine;
            while ((caseLine = fileInput.readLine())!=null){
                short []currentCase = processCase(caseLine ,12);
                this.chairperson = new Chairperson();
                int winner = 0;//this.chairperson.playTestGame(gameType,classifications,currentCase);                
                if(winner == correctClass){
                    correct++;
                    System.out.println("1");
                }
                else System.out.println("0");                   	
            }
            this.rounds[this.roundsIndx] = this.chairperson.getRounds();
            roundsIndx++;
            this.outPutTestSummary(testName, correct, cases);
        }
        catch (IOException ioException){
            System.out.println("Error reading from file: " + caseFile + "\n");
            System.exit(1);
        }
    }
    /***/
    protected void outPutTestSummary(String testName, int correct, int cases){
        String fileName = "/users/agent/maya/PISAResults/PISAResults.txt";
        FileWriter fileOutput;
        //write the dialogue
        try{
            fileOutput= new FileWriter(fileName, true);
            fileOutput.write("TEST: " + testName+"\n");              
            fileOutput.write("Corrects: " + correct + "\n");
            fileOutput.write("Rounds Deviation:" + this.roundsDeviation() + "\n" );            
            fileOutput.write("----------------------------------------------------------------\n");  
            fileOutput.flush();
            fileOutput.close();
        }	
        catch (IOException ioException){
            System.out.println("Error writing to File: " + fileName + "\n");
        }
    }
    
}
